"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Bluebird = require("bluebird");
const fs = require("fs");
const _read = Bluebird.promisify(fs.read, { context: fs, multiArgs: true });
const _write = Bluebird.promisify(fs.write, { context: fs, multiArgs: true });
exports.open = Bluebird.promisify(fs.open, { context: fs });
exports.close = Bluebird.promisify(fs.close, { context: fs });
exports.fstat = Bluebird.promisify(fs.fstat, { context: fs });
exports.fdatasync = Bluebird.promisify(fs.fdatasync, { context: fs });
exports.read = (fd, buffer, offset, length, position) => {
    return _read(fd, buffer, offset, length, position)
        .spread((bytesRead, buffer) => {
        return { bytesRead, buffer };
    });
};
exports.write = (fd, buffer, offset, length, position) => {
    return _write(fd, buffer, offset, length, position)
        .spread((bytesWritten, buffer) => {
        return { bytesWritten, buffer };
    });
};
//# sourceMappingURL=fs.js.map